from visual import *

floor = box(pos = vector(0,0,0),length=50, height = 0.5, width = 20,color=color.blue)


r1=2
r2=2

ball1 = sphere(pos = vector(-floor.length/2+r1,floor.height+r1,0),radius =r1,color=color.red)
ball2 = sphere(pos = vector(+floor.length/2-r2,floor.height+r2,0),radius =r2,color=color.white)

L=floor.length
gray = (0.7,0.7,0.7)
yaxis2 = curve(pos=[(-L/2-ball1.radius-1,0,0), (-L/2-ball1.radius-1,L,0)], width = 20, color=gray)
yaxis3 = curve(pos=[(+L/2+ball1.radius+1,0,0), (+L/2+ball1.radius+1,L,0)], color=gray)


#############initial conditions
mass = 0.1
drag_coeff = 0.0
f_wind = vector(0,0,0.0)
g=vector(0,0,0)
restitution = 1.0
velocity_ball1 = vector(10.0,0,0)
velocity_ball2 = vector(-10.0,0,0)
t = 0
dt = 0.01

while t<2000:   
   # if abs(ball1.pos.x)<floor.length/2+ball1.radius:
   force_on_ball1 = mass*g+f_wind-drag_coeff*velocity_ball1
   acceleration_ball1 = force_on_ball1/mass
   velocity_ball1 = velocity_ball1 + acceleration_ball1*dt
   ball1.pos = ball1.pos+velocity_ball1*dt+0.5*acceleration_ball1*dt**2
    #if abs(ball2.pos.x)<floor.length/2+ball2.radius:
   force_on_ball2 = mass*g+f_wind-drag_coeff*velocity_ball2
   acceleration_ball2 = force_on_ball2/mass
   velocity_ball2 = velocity_ball2 + acceleration_ball2*dt
   ball2.pos = ball2.pos+velocity_ball2*dt+0.5*acceleration_ball2*dt**2
   t=t+dt
   rate(1.0/dt)
   po=abs(ball1.pos-ball2.pos)
   vel1=velocity_ball1.x
   vel2=velocity_ball2.x
   if po<=(ball1.radius+ball2.radius):
     velocity_ball1.x=vel2
     velocity_ball2.x=vel1
   if abs(ball1.pos.x)>floor.length/2+ball1.radius:
       velocity_ball1.x=-vel1
   if abs(ball2.pos.x)>floor.length/2+ball2.radius:
       velocity_ball2.x=-vel2

     

