from visual import *

col = (1.7,0.7,0.1)
r = 1.5
floor = box(pos =vector(0,0,0),length=50.0 , height =1.0 , width = 20.0,
            color =col)
ball = sphere(pos=vector(-floor.length/2.0, floor.height/2+r,0), radius = r , color=color.green)

goal = ring(pos=(floor.length/4.0+r+1, 5*floor.height+r,0), axis=vector(0,1,0),
            radius = 3*r , color = color.red)

trail =curve(color=ball.color)

#################### initial conditions
f_wind=vector(0,0,0)
g=vector(0,-9.8,0)
mass=1.0
drag_coeff=0.0
rest=1.0
vx=5.0
vy=10.0
vz=0.0
velocity_ball=vector(vx,vy,vz)
t=0.0
dt=0.01
############################

while abs(ball.pos.x) <=floor.length/2.0 and abs(ball.pos.z) <=floor.width/2.0:
     force_on_ball=mass*g+f_wind-drag_coeff*velocity_ball
     acceleration_ball=force_on_ball/mass
     velocity_ball=velocity_ball+acceleration_ball*dt
     ball.pos=ball.pos+velocity_ball*dt+0.5*acceleration_ball*dt**2
     if ball.pos.y<ball.radius+floor.height/2.0:
         velocity_ball.y=-rest*velocity_ball.y
         ball.pos.y=ball.radius+floor.height/2.0
     t=t+dt
     trail.append(pos=ball.pos)
     rate(1.0/dt)

